# -- coding: utf-8 --

# efektiivne lahendus sorteerimise ja kahendotsingutega
# O(N*log(N) + M*log(N)) - sorteerimine + korduvad kahendotsingud

import sys
from bisect import bisect_left

n = int(sys.stdin.readline().strip())
aa = [int(a) for a in sys.stdin.readline().split()]
# paneme iga elemendi kõrvale tema positsiooni esialgses jadas
# siis sorteerime tulemuse elementide kasvamise järjekorras
aa = sorted([(aa[i], i) for i in range(n)])
# alternatiiv: aa = sorted(zip(aa, range(n)))

m = int(sys.stdin.readline().strip())
qq = [int(q) for q in sys.stdin.readline().split()]

for q in qq:
	# selline p1, et aa[p1 - 1][0] < q <= aa[p1][0]
	p1 = bisect_left(aa, (q, 0))
	if p1 == 0:
		# minimaalse elemendi vasakpoolseim esinemiskoht
		best = aa[0][1]
	elif p1 == len(aa):
		# maksimaalse elemendi vasakpoolseim esinemiskoht
		a = aa[-1][0]
		p2 = bisect_left(aa, (a, 0))
		best = aa[p2][1]
	else:
		# minimaalselt väiksema elemendi vasakpoolseim esinemiskoht
		a = aa[p1 - 1][0]
		p2 = bisect_left(aa, (a, 0))
		if aa[p1][0] - q < q - aa[p2][0]:
			best = aa[p1][1]
		elif aa[p1][0] - q > q - aa[p2][0]:
			best = aa[p2][1]
		else: # aa[p1][0] - q == q - aa[p2][0]
			best = min(aa[p1][1], aa[p2][1])
	sys.stdout.write("{}\n".format(1 + best))
