# -- coding: utf-8 --

# efektiivne lahendus sorteerimise, sõnastiku ja kahendotsingutega
# O(N*log(N) + M*log(N)) - sorteerimine + korduvad kahendotsingud

import sys
from bisect import bisect_left

n = int(sys.stdin.readline().strip())
aa = [int(a) for a in sys.stdin.readline().split()]

# leiame iga jadas esineva väärtuse jaoks selle vasakpoolseima esinemiskoha
pp = {}
for i, a in enumerate(aa):
	if a not in pp:
		pp[a] = i

aa.sort()

m = int(sys.stdin.readline().strip())
qq = [int(q) for q in sys.stdin.readline().split()]

for q in qq:
	# selline p, et aa[p - 1] < q <= aa[p]
	p = bisect_left(aa, q)
	if p == 0:
		best = aa[0]
	elif p == len(aa):
		best = aa[-1]
	elif aa[p] - q < q - aa[p - 1]:
		best = aa[p]
	elif aa[p] - q > q - aa[p - 1]:
		best = aa[p - 1]
	elif pp[aa[p]] < pp[aa[p - 1]]:
		best = aa[p]
	else:
		best = aa[p - 1]
	sys.stdout.write("{}\n".format(1 + pp[best]))
